// generation d'arbres par les L-systemes
// dans cette variante, a chaque frame, on redessine l'arbre avec un petit decalage angulaire aleatoire
// donne l'impression d'un arbre dans le vent...
// Pierre Cubaud, cubaud@cnam.fr, mars 2009

//String lsyst="F"; String regleF = "F[+F]F[-F]F"; String regleX = ""; int NMAX = 5; float delta = 25.7; float D = 10;
//String lsyst="X"; String regleF = "FF"; String regleX = "F[+X][-X]FX"; int NMAX = 8; float delta = 25.7; float D = 10;
String lsyst="F"; String regleF = "FF-[-F+F+F]+[+F-F-F]"; String regleX = ""; int NMAX = 4; float delta = 22.5; float D = 30;
//String lsyst="F-F-F-F"; String regleF = "F+F-F-FF+F+F-F"; String regleX = ""; int NMAX = 4; float delta = 90.0; float D = 30;

void setup(){
 size(600,600);
 stroke(0);
 frameRate(10);
 // expansion du L-systeme
 for (int n=0; n<NMAX; n++) {
  lsyst=lsyst.replaceAll("F",regleF);
 lsyst=lsyst.replaceAll("X",regleX);
 println("NIVEAU "+n);
 println(lsyst);
 }
 delta *= PI/180;
 D /= float(NMAX);
}

void draw(){
fill(255,200);rect(0,0,width,height);
resetMatrix();
// dessin
translate(width/2,height);
for (int i=0; i<lsyst.length(); i++){
  char c = lsyst.charAt(i);
  switch(c){
    case 'F' : line(0,0,0,-D); translate(0,-D); break;
    case '+' : rotate(random(-delta-0.05,-delta+0.05)); break;
    case '-' : rotate(random(delta-0.05,delta+0.05)); break;
    case '[' : pushMatrix(); break;
    case ']' : popMatrix();break;
    default : break;
  }
}  
}            
             
